Subject: bug#7879: closed (Re: 24.0.50; Wish: Make c-defun-name recognize objc-methods.)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 14 Jul 2012 09:17:02 +0000

Your bug report

#7879: 24.0.50; Wish: Make c-defun-name recognize objc-methods.

which was filed against the emacs,cc-mode package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
7879: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=7879
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: 24.0.50; Wish: Make c-defun-name recognize objc-methods.
From: Jan Djärv <[email-masked]>
To: [email-masked]
Date: Sat, 14 Jul 2012 11:10:49 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Patch checked in.

	Jan D.

Subject: 24.0.50; Wish: Make c-defun-name recognize objc-methods.
From: Jan Djärv <[email-masked]>
To: [email-masked]
Date: Fri, 21 Jan 2011 10:07:17 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

This bug report will be sent to the Free Software Foundation,
not to your local site managers!
Please write in English if possible, because the Emacs maintainers
usually do not have translators to read other languages for them.

Your report will be posted to the [email-masked] mailing list
and the gnu.emacs.bug news group, and at http://debbugs.gnu.org.

Please describe exactly what actions triggered the bug
and the precise symptoms of the bug.  If you can, give
a recipe starting from `emacs -Q':

Hello.

bug-cc-mode seems to be dead, so I send here instead.

It always annoyed me that add-log always put objc-methods as "-".
Internally add-log uses c-defun-name, so I'd like that defun to be
changed so it recognizes objc-names.  I have run with this for a while,
it handles all cases I've seen, but I'm sure some constructs make it
fail.  At least it is better than returning "-".

=== modified file 'lisp/progmodes/cc-cmds.el'
--- lisp/progmodes/cc-cmds.el	2010-10-31 11:54:02 +0000
+++ lisp/progmodes/cc-cmds.el	2010-12-02 09:03:09 +0000
@@ -1724,6 +1724,14 @@
   	    ;; DEFFLAGSET(syslog_opt_flags,LOG_PID ...) ==> syslog_opt_flags
   	    (match-string-no-properties 1))

+	   ((and (derived-mode-p 'objc-mode)
+		 (looking-at "[-+]\s*("))
+	    (when (c-syntactic-re-search-forward ")\s*" nil t)
+	      (c-forward-token-2)
+	      (setq name-end (point))
+	      (c-backward-token-2)
+	      (buffer-substring-no-properties (point) name-end)))
+
   	   (t
   	    ;; Normal function or initializer.
   	    (when (c-syntactic-re-search-forward "[{(]" nil t)

	Jan D.

If Emacs crashed, and you have the Emacs process in the gdb debugger,
please include the output from the following gdb commands:
     `bt full' and `xbacktrace'.
For information about debugging Emacs, please read the file
/Users/jhd/src/emacs/current/nextstep/Emacs.app/Contents/Resources/etc/DEBUG.

In GNU Emacs 24.0.50.1 (x86_64-apple-darwin10.6.0, NS apple-appkit-1038.35)
  of 2011-01-21 on zeplin
Windowing system distributor `Apple', version 10.3.1038
configured using `configure  '--verbose' '--enable-asserts' '--with-ns' 
'--without-x' 'CFLAGS=-g''

Important settings:
   value of $LC_ALL: nil
   value of $LC_COLLATE: C
   value of $LC_CTYPE: nil
   value of $LC_MESSAGES: nil
   value of $LC_MONETARY: nil
   value of $LC_NUMERIC: nil
   value of $LC_TIME: nil
   value of $LANG: sv_SE.UTF-8
   value of $XMODIFIERS: nil
   locale-coding-system: utf-8-unix
   default enable-multibyte-characters: t

Major mode: Lisp Interaction

Minor modes in effect:
   desktop-save-mode: t
   delete-selection-mode: t
   icomplete-mode: t
   display-time-mode: t
   tooltip-mode: t
   mouse-wheel-mode: t
   tool-bar-mode: t
   menu-bar-mode: t
   file-name-shadow-mode: t
   global-font-lock-mode: t
   font-lock-mode: t
   auto-composition-mode: t
   auto-encryption-mode: t
   auto-compression-mode: t
   line-number-mode: t
   transient-mark-mode: t

Recent input:
n M-x r e p o r t - e m <tab> <return>

Recent messages:
Loading /Users/jhd/lib/elisp/BAK-file.el (source)...done
Loading /Users/jhd/lib/elisp/ccsetup.el (source)...done
Loading icomplete...done
Loading desktop...done
Warning: desktop file appears to be in use by PID 29264.
Using it may cause conflicts.  Use it anyway? (y or n)  n
Desktop file in use; not loaded.
For information about GNU Emacs and the GNU system, type C-h C-a.

Load-path shadows:
None found.

Features:
(shadow sort gnus-util mail-extr message rfc822 mml mml-sec mm-decode
mm-bodies mm-encode mail-parse rfc2231 rfc2047 rfc2045 ietf-drums
mm-util mail-prsvr mailabbrev mail-utils gmm-utils mailheader emacsbug
desktop cus-start cus-load msb delsel advice help-fns advice-preload
icomplete cc-mode cc-fonts easymenu cc-menus cc-cmds cc-styles cc-align
cc-engine cc-vars cc-defs regexp-opt time tooltip ediff-hook vc-hooks
lisp-float-type mwheel ns-win tool-bar dnd fontset image fringe
lisp-mode register page menu-bar rfn-eshadow timer select scroll-bar
mouse jit-lock font-lock syntax facemenu font-core frame cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese hebrew greek romanian slovak czech european ethiopic indian
cyrillic chinese case-table epa-hook jka-cmpr-hook help simple abbrev
loaddefs button minibuffer faces cus-face files text-properties overlay
md5 base64 format env code-pages mule custom widget
hashtable-print-readable backquote make-network-process ns multi-tty
emacs)